]> git.proxmox.com Git - ovs.git/blob - utilities/ovs-lib.in
090a14434283ebc8a1d951986193fad080b0227e
[ovs.git] / utilities / ovs-lib.in
1 # -*- sh -*-
2 # vi:syntax=sh
3 # This is a shell function library sourced by some Open vSwitch scripts.
4 # It is not intended to be invoked on its own.
5
6 # Copyright (C) 2009, 2010, 2011, 2012 Nicira, Inc.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License");
9 # you may not use this file except in compliance with the License.
10 # You may obtain a copy of the License at:
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS,
16 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
17 # See the License for the specific language governing permissions and
18 # limitations under the License.
19
20 ## ----------------- ##
21 ## configure options ##
22 ## ----------------- ##
23
24 # All of these should be substituted by the Makefile at build time.
25 logdir=${OVS_LOGDIR-'@LOGDIR@'} # /var/log/openvswitch
26 rundir=${OVS_RUNDIR-'@RUNDIR@'} # /var/run/openvswitch
27 sysconfdir=${OVS_SYSCONFDIR-'@sysconfdir@'} # /etc
28 etcdir=$sysconfdir/openvswitch # /etc/openvswitch
29 datadir=${OVS_PKGDATADIR-'@pkgdatadir@'} # /usr/share/openvswitch
30 bindir=${OVS_BINDIR-'@bindir@'} # /usr/bin
31 sbindir=${OVS_SBINDIR-'@sbindir@'} # /usr/sbin
32
33 # /etc/openvswitch or /var/lib/openvswitch
34 if test X"$OVS_DBDIR" != X; then
35 dbdir=$OVS_DBDIR
36 elif test X"$OVS_SYSCONFDIR" != X; then
37 dbdir=$OVS_SYSCONFDIR/openvswitch
38 else
39 dbdir='@DBDIR@'
40 fi
41
42 ovs_ctl_log () {
43 echo "$@" >> "${logdir}/ovs-ctl.log"
44 }
45
46 ovs_ctl () {
47 case "$@" in
48 *"=strace"*)
49 # In case of running the daemon with strace, piping the o/p causes
50 # the script to block (strace probably does not close the inherited
51 # pipe). So, do not log the o/p to ovs-ctl.log.
52 "${datadir}/scripts/ovs-ctl" "$@"
53 ;;
54 "status")
55 # In case of the command 'status', we should return the exit status
56 # of ovs-ctl. It is also useful to document the o/p in ovs-ctl.log.
57 display=`"${datadir}/scripts/ovs-ctl" "$@" 2>&1`
58 rc=$?
59 if test -w "${logdir}/ovs-ctl.log"; then
60 echo "${display}" | tee -a "${logdir}/ovs-ctl.log"
61 else
62 echo "${display}"
63 fi
64 return ${rc}
65 ;;
66 *)
67 echo "`date -u`:$@" >> "${logdir}/ovs-ctl.log"
68 "${datadir}/scripts/ovs-ctl" "$@" 2>&1 | tee -a "${logdir}/ovs-ctl.log"
69 ;;
70 esac
71 }
72
73 VERSION='@VERSION@'
74
75 DAEMON_CWD=/
76
77 LC_ALL=C; export LC_ALL
78
79 ## ------------- ##
80 ## LSB functions ##
81 ## ------------- ##
82
83 # Use the system's own implementations if it has any.
84 if test -e /etc/init.d/functions; then
85 . /etc/init.d/functions
86 elif test -e /etc/rc.d/init.d/functions; then
87 . /etc/rc.d/init.d/functions
88 elif test -e /lib/lsb/init-functions; then
89 . /lib/lsb/init-functions
90 fi
91
92 # Implement missing functions (e.g. OpenSUSE lacks 'action').
93 if type log_success_msg >/dev/null 2>&1; then :; else
94 log_success_msg () {
95 printf '%s.\n' "$*"
96 }
97 fi
98 if type log_failure_msg >/dev/null 2>&1; then :; else
99 log_failure_msg () {
100 printf '%s ... failed!\n' "$*"
101 }
102 fi
103 if type log_warning_msg >/dev/null 2>&1; then :; else
104 log_warning_msg () {
105 printf '%s ... (warning).\n' "$*"
106 }
107 fi
108 if type action >/dev/null 2>&1; then :; else
109 action () {
110 STRING=$1
111 shift
112 "$@"
113 rc=$?
114 if test $rc = 0; then
115 log_success_msg "$STRING"
116 else
117 log_failure_msg "$STRING"
118 fi
119 return $rc
120 }
121 fi
122
123 ## ------- ##
124 ## Daemons ##
125 ## ------- ##
126
127 pid_exists () {
128 # This is better than "kill -0" because it doesn't require permission to
129 # send a signal (so daemon_status in particular works as non-root).
130 test -d /proc/"$1"
131 }
132
133 pid_comm_check () {
134 [ "$1" = "`cat /proc/$2/comm`" ]
135 }
136
137 # version_geq version_a version_b
138 #
139 # Compare (dot separated) version numbers. Returns true (exit code 0) if
140 # version_a is greater or equal than version_b, otherwise false (exit code 1).
141 version_geq() {
142 echo $1 $2 | awk '{
143 n1 = split($1, a, ".");
144 n2 = split($2, b, ".");
145 n = (n1 > n2) ? n1 : n2;
146 for (i = 1; i <= n; i++) {
147 if (a[i]+0 < b[i]+0) exit 1
148 if (a[i]+0 > b[i]+0) exit 0
149 }
150 }'
151 }
152
153 install_dir () {
154 DIR="$1"
155 INSTALL_MODE="${2:-755}"
156 INSTALL_USER="root"
157 INSTALL_GROUP="root"
158 [ "$OVS_USER" != "" ] && INSTALL_USER="${OVS_USER%:*}"
159 [ "${OVS_USER##*:}" != "" ] && INSTALL_GROUP="${OVS_USER##*:}"
160
161 if test ! -d "$DIR"; then
162 install -d -m "$INSTALL_MODE" -o "$INSTALL_USER" -g "$INSTALL_GROUP" "$DIR"
163 restorecon "$DIR" >/dev/null 2>&1
164 fi
165 }
166
167 start_daemon () {
168 priority=$1
169 wrapper=$2
170 shift; shift
171 daemon=$1
172 strace=""
173
174 # drop core files in a sensible place
175 install_dir "$DAEMON_CWD"
176 set "$@" --no-chdir
177 cd "$DAEMON_CWD"
178
179 # log file
180 install_dir "$logdir" "750"
181 set "$@" --log-file="$logdir/$daemon.log"
182
183 # pidfile and monitoring
184 install_dir "$rundir"
185 set "$@" --pidfile="$rundir/$daemon.pid"
186 set "$@" --detach
187 test X"$MONITOR" = Xno || set "$@" --monitor
188
189 # wrapper
190 case $wrapper in
191 valgrind)
192 if (valgrind --version) > /dev/null 2>&1; then
193 set valgrind -q --leak-check=full --time-stamp=yes \
194 --log-file="$logdir/$daemon.valgrind.log.%p" "$@"
195 else
196 log_failure_msg "valgrind not installed, running $daemon without it"
197 fi
198 ;;
199 strace)
200 if (strace -V) > /dev/null 2>&1; then
201 strace="strace -tt -T -s 256 -ff"
202 if (strace -DV) > /dev/null 2>&1; then
203 # Has the -D option.
204 set $strace -D -o "$logdir/$daemon.strace.log" "$@"
205 strace=""
206 fi
207 else
208 log_failure_msg "strace not installed, running $daemon without it"
209 fi
210 ;;
211 glibc)
212 set env MALLOC_CHECK_=2 MALLOC_PERTURB_=165 "$@"
213 ;;
214 '')
215 ;;
216 *)
217 log_failure_msg "unknown wrapper $wrapper, running $daemon without it"
218 ;;
219 esac
220
221 # priority
222 if test X"$priority" != X; then
223 set nice -n "$priority" "$@"
224 fi
225
226 action "Starting $daemon" "$@" || return 1
227
228 if test X"$strace" != X; then
229 # Strace doesn't have the -D option so we attach after the fact.
230 setsid $strace -o "$logdir/$daemon.strace.log" \
231 -p `cat $rundir/$daemon.pid` > /dev/null 2>&1 &
232 fi
233 }
234
235 stop_daemon () {
236 if test -e "$rundir/$1.pid"; then
237 if pid=`cat "$rundir/$1.pid"`; then
238
239 graceful="EXIT .1 .25 .65 1"
240 actions="TERM .1 .25 .65 1 1 1 1 \
241 KILL 1 1 1 2 10 15 30 \
242 FAIL"
243 version=`ovs-appctl -T 1 -t $rundir/$1.$pid.ctl version \
244 | awk 'NR==1{print $NF}'`
245
246 # Use `ovs-appctl exit` only if the running daemon version
247 # is >= 2.5.90. This script might be used during upgrade to
248 # stop older versions of daemons which do not behave correctly
249 # with `ovs-appctl exit` (e.g. ovs-vswitchd <= 2.5.0 deletes
250 # internal ports).
251 if version_geq "$version" "2.5.90"; then
252 actions="$graceful $actions"
253 fi
254 for action in $actions; do
255 if pid_exists "$pid" >/dev/null 2>&1; then :; else
256 return 0
257 fi
258 case $action in
259 EXIT)
260 action "Exiting $1 ($pid)" \
261 ${bindir}/ovs-appctl -T 1 -t $rundir/$1.$pid.ctl exit $2
262 ;;
263 TERM)
264 action "Killing $1 ($pid)" kill $pid
265 ;;
266 KILL)
267 action "Killing $1 ($pid) with SIGKILL" kill -9 $pid
268 ;;
269 FAIL)
270 log_failure_msg "Killing $1 ($pid) failed"
271 return 1
272 ;;
273 *)
274 sleep $action
275 ;;
276 esac
277 done
278 fi
279 fi
280 log_success_msg "$1 is not running"
281 }
282
283 daemon_status () {
284 pidfile=$rundir/$1.pid
285 if test -e "$pidfile"; then
286 if pid=`cat "$pidfile"`; then
287 if pid_exists "$pid"; then
288 echo "$1 is running with pid $pid"
289 return 0
290 else
291 echo "Pidfile for $1 ($pidfile) is stale"
292 fi
293 else
294 echo "Pidfile for $1 ($pidfile) exists but cannot be read"
295 fi
296 else
297 echo "$1 is not running"
298 fi
299 return 1
300 }
301
302 daemon_is_running () {
303 pidfile=$rundir/$1.pid
304 test -e "$pidfile" && pid=`cat "$pidfile"` && pid_exists "$pid" && pid_comm_check $1 $pid
305 } >/dev/null 2>&1
306
307 # Prints commands needed to move the ip address from interface $1 to interface
308 # $2
309 move_ip_address () {
310 if [ -z "$1" ] || [ -z "$2" ]; then
311 return
312 fi
313 dev="$1"
314 dst="$2"
315
316 # IP addresses (including IPv6).
317 echo "ip addr flush dev $dev 2>/dev/null" # Suppresses "Nothing to flush".
318 ip addr show dev $dev | while read addr; do
319 set -- $addr
320
321 # Check and trim family.
322 family=$1
323 shift
324 case $family in
325 inet | inet6) ;;
326 *) continue ;;
327 esac
328
329 # Trim device off the end--"ip" insists on having "dev" precede it.
330 addrcmd=
331 while test $# != 0; do
332 case $1 in
333 dynamic)
334 # XXX: According to 'man ip-address', "dynamic" is only
335 # used for ipv6 addresses. But, atleast on RHEL 7.4
336 # (iproute-3.10.0-87), it is being used for ipv4
337 # addresses assigned with dhcp.
338 if [ "$family" = "inet" ]; then
339 shift
340 continue
341 fi
342 # Omit kernel-maintained route.
343 continue 2
344 ;;
345 scope)
346 if test "$2" = link -a "$family" != inet6; then
347 # Omit route derived from IP address, e.g.
348 # 172.16.0.0/16 derived from 172.16.12.34,
349 # but preserve IPv6 link-local address.
350 continue 2
351 fi
352 ;;
353 "$dev"|"$dev:"*)
354 # Address label string
355 label=`echo $1 | sed "s/$dev/$dst/"`
356 addrcmd="$addrcmd label $label"
357 shift
358 continue
359 ;;
360 esac
361 addrcmd="$addrcmd $1"
362 shift
363 done
364 if test "$1" != "$dev"; then
365 addrcmd="$addrcmd $1"
366 fi
367
368 echo ip -f $family addr add $addrcmd dev $dst
369 done
370 }
371
372 # Prints commands needed to move the ip route of interface $1 to interface $2
373 move_ip_routes () {
374 if [ -z "$1" ] || [ -z "$2" ]; then
375 return
376 fi
377 dev="$1"
378 dst="$2"
379 echo "ip route flush dev $dev proto boot 2>/dev/null" # Suppresses "Nothing to flush".
380 ip route show dev $dev | while read route; do
381 # "proto kernel" routes are installed by the kernel automatically.
382 case $route in
383 *" proto kernel "*) continue ;;
384 esac
385
386 echo "ip route add $route dev $dst"
387 done
388 }
389
390 ovsdb_tool () {
391 if [ "$OVS_USER" != "" ]; then
392 local uid=$(id -u "${OVS_USER%:*}")
393 local gid=$(id -g "${OVS_USER%:*}")
394 local groups=$(id -G "${OVS_USER%:*}" | tr ' ' ',')
395 setpriv --reuid "$uid" --regid "$gid" --groups "$groups" ovsdb-tool -vconsole:off "$@"
396 else
397 ovsdb-tool -vconsole:off "$@"
398 fi
399 }
400
401 create_db () {
402 DB_FILE="$1"
403 DB_SCHEMA="$2"
404 action "Creating empty database $DB_FILE" ovsdb_tool create "$DB_FILE" "$DB_SCHEMA"
405 }
406
407 backup_db () {
408 # Back up the old version.
409 version=`ovsdb_tool db-version "$DB_FILE"`
410 cksum=`ovsdb_tool db-cksum "$DB_FILE" | awk '{print $1}'`
411 backup=$DB_FILE.backup$version-$cksum
412 action "Backing up database to $backup" cp "$DB_FILE" "$backup" || return 1
413 }
414
415 upgrade_db () {
416 DB_FILE="$1"
417 DB_SCHEMA="$2"
418
419 schemaver=`ovsdb_tool schema-version "$DB_SCHEMA"`
420 if test ! -e "$DB_FILE"; then
421 log_warning_msg "$DB_FILE does not exist"
422 install_dir `dirname $DB_FILE`
423 create_db "$DB_FILE" "$DB_SCHEMA"
424 elif test X"`ovsdb_tool needs-conversion "$DB_FILE" "$DB_SCHEMA"`" = Xyes; then
425 backup_db || return 1
426
427 # Compact database. This is important if the old schema did not enable
428 # garbage collection (i.e. if it did not have any tables with "isRoot":
429 # true) but the new schema does. In that situation the old database
430 # may contain a transaction that creates a record followed by a
431 # transaction that creates the first use of the record. Replaying that
432 # series of transactions against the new database schema (as "convert"
433 # does) would cause the record to be dropped by the first transaction,
434 # then the second transaction would cause a referential integrity
435 # failure (for a strong reference).
436 #
437 # Errors might occur on an Open vSwitch downgrade if ovsdb-tool doesn't
438 # understand some feature of the schema used in the OVSDB version that
439 # we're downgrading from, so we don't give up on error.
440 action "Compacting database" ovsdb_tool compact "$DB_FILE"
441
442 # Upgrade or downgrade schema.
443 if action "Converting database schema" ovsdb_tool convert "$DB_FILE" "$DB_SCHEMA"; then
444 :
445 else
446 log_warning_msg "Schema conversion failed, using empty database instead"
447 rm -f "$DB_FILE"
448 create_db "$DB_FILE" "$DB_SCHEMA"
449 fi
450 fi
451 }
452
453 upgrade_cluster () {
454 local DB_SCHEMA=$1 DB_SERVER=$2
455 local schema_name=$(ovsdb-tool schema-name $1) || return 1
456
457 action "Waiting for $schema_name to come up" ovsdb-client -t 30 wait "$DB_SERVER" "$schema_name" connected || return $?
458 local db_version=$(ovsdb-client -t 10 get-schema-version "$DB_SERVER" "$schema_name") || return $?
459 local target_version=$(ovsdb-tool schema-version "$DB_SCHEMA") || return $?
460
461 if ovsdb-tool compare-versions "$db_version" == "$target_version"; then
462 :
463 elif ovsdb-tool compare-versions "$db_version" ">" "$target_version"; then
464 log_warning_msg "Database $schema_name has newer schema version ($db_version) than our local schema ($target_version), possibly an upgrade is partially complete?"
465 else
466 action "Upgrading database $schema_name from schema version $db_version to $target_version" ovsdb-client -t 30 convert "$DB_SERVER" "$DB_SCHEMA"
467 fi
468 }
469
470 create_cluster () {
471 DB_FILE="$1"
472 DB_SCHEMA="$2"
473 LOCAL_ADDR="$3"
474
475 if test ! -e "$DB_FILE"; then
476 action "Creating cluster database $DB_FILE" ovsdb_tool create-cluster "$DB_FILE" "$DB_SCHEMA" "$LOCAL_ADDR"
477 elif ovsdb_tool db-is-standalone "$DB_FILE"; then
478 # Convert standalone database to clustered.
479 backup_db || return 1
480 action "Creating cluster database $DB_FILE from existing one" \
481 ovsdb_tool create-cluster "$DB_FILE" "$backup" "$LOCAL_ADDR"
482 fi
483 }
484
485 join_cluster() {
486 DB_FILE="$1"
487 SCHEMA_NAME="$2"
488 LOCAL_ADDR="$3"
489 REMOTE_ADDR="$4"
490
491 if test ! -e "$DB_FILE"; then
492 ovsdb_tool join-cluster "$DB_FILE" "$SCHEMA_NAME" "$LOCAL_ADDR" "$REMOTE_ADDR"
493 elif ovsdb_tool db-is-standalone "$DB_FILE"; then
494 # Backup standalone database and join cluster.
495 backup_db || return 1
496 action "Joining $DB_FILE to cluster" \
497 ovsdb_tool join-cluster "$DB_FILE" "$SCHEMA_NAME" "$LOCAL_ADDR"
498 fi
499 }
500
501 ovs_vsctl () {
502 ovs-vsctl --no-wait "$@"
503 }
504
505 ## ----------------- ##
506 ## force-reload-kmod ##
507 ## ----------------- ##
508
509 ovs_kmod_ctl () {
510 "$dir0/ovs-kmod-ctl" "$@"
511 }
512
513 internal_interfaces () {
514 # Outputs a list of internal interfaces:
515 #
516 # - There is an internal interface for every bridge, whether it
517 # has an Interface record or not and whether the Interface
518 # record's 'type' is properly set or not.
519 #
520 # - There is an internal interface for each Interface record whose
521 # 'type' is 'internal'.
522 #
523 # But ignore interfaces that don't really exist.
524 for d in `(ovs_vsctl --bare \
525 -- --columns=name find Interface type=internal \
526 -- list-br) | sort -u`
527 do
528 if test -e "/sys/class/net/$d"; then
529 printf "%s " "$d"
530 fi
531 done
532 }
533
534 ovs_save () {
535 bridges=`ovs_vsctl -- --real list-br`
536 if [ -n "${bridges}" ] && \
537 "$datadir/scripts/ovs-save" "$1" ${bridges} > "$2"; then
538 chmod +x "$2"
539 return 0
540 fi
541 [ -z "${bridges}" ] && return 0
542 }
543
544 save_flows_if_required () {
545 if test X"$DELETE_BRIDGES" != Xyes; then
546 action "Saving flows" ovs_save save-flows "${script_flows}"
547 fi
548 }
549
550 save_interfaces () {
551 "$datadir/scripts/ovs-save" save-interfaces ${ifaces} \
552 > "${script_interfaces}"
553 }
554
555 flow_restore_wait () {
556 if test X"${OVS_VSWITCHD:-yes}" = Xyes; then
557 ovs_vsctl set open_vswitch . other_config:flow-restore-wait="true"
558 fi
559 }
560
561 flow_restore_complete () {
562 if test X"${OVS_VSWITCHD:-yes}" = Xyes; then
563 ovs_vsctl --if-exists remove open_vswitch . other_config \
564 flow-restore-wait="true"
565 fi
566 }
567
568 restore_flows () {
569 [ -x "${script_flows}" ] && \
570 action "Restoring saved flows" "${script_flows}"
571 }
572
573 restore_interfaces () {
574 [ ! -x "${script_interfaces}" ] && return 0
575 action "Restoring interface configuration" "${script_interfaces}"
576 rc=$?
577 if test $rc = 0; then
578 level=debug
579 else
580 level=err
581 fi
582 log="logger -p daemon.$level -t ovs-save"
583 $log "interface restore script exited with status $rc:"
584 $log -f "$script_interfaces"
585 }
586
587 init_restore_scripts () {
588 script_interfaces=`mktemp`
589 script_flows=`mktemp`
590 trap 'rm -f "${script_interfaces}" "${script_flows}"' 0
591 }
592
593 force_reload_kmod () {
594
595 if test X"${OVS_VSWITCHD:-yes}" != Xyes; then
596 log_failure_msg "Reloading of kmod without ovs-vswitchd is an error"
597 exit 1
598 fi
599
600 ifaces=`internal_interfaces`
601 action "Detected internal interfaces: $ifaces" true
602
603 init_restore_scripts
604 save_flows_if_required
605
606 # Restart the database first, since a large database may take a
607 # while to load, and we want to minimize forwarding disruption.
608 stop_ovsdb
609 start_ovsdb || return 1
610
611 if [ -n "$(ovs-dpctl show)" ]; then
612 action "Flush old conntrack entries" ovs-appctl dpctl/flush-conntrack
613 fi
614 stop_forwarding
615
616 if action "Saving interface configuration" save_interfaces; then
617 :
618 else
619 log_warning_msg "Failed to save configuration, not replacing kernel module"
620 start_forwarding
621 add_managers
622 exit 1
623 fi
624 chmod +x "$script_interfaces"
625
626 for dp in `ovs-dpctl dump-dps`; do
627 action "Removing datapath: $dp" ovs-dpctl del-dp "$dp"
628 done
629
630 ovs_kmod_ctl remove
631
632 # Start vswitchd by asking it to wait till flow restore is finished.
633 flow_restore_wait
634 start_forwarding || return 1
635
636 # Restore saved flows and inform vswitchd that we are done.
637 restore_flows
638 flow_restore_complete
639 add_managers
640
641 restore_interfaces
642
643 "$datadir/scripts/ovs-check-dead-ifs"
644 }
645
646 ## ------- ##
647 ## restart ##
648 ## ------- ##
649
650 restart () {
651 if daemon_is_running ovsdb-server && daemon_is_running ovs-vswitchd; then
652 init_restore_scripts
653 if test X"${OVS_VSWITCHD:-yes}" = Xyes; then
654 save_flows_if_required
655 fi
656 fi
657
658 # Restart the database first, since a large database may take a
659 # while to load, and we want to minimize forwarding disruption.
660 stop_ovsdb
661 start_ovsdb || return 1
662
663 stop_forwarding
664
665 # Start vswitchd by asking it to wait till flow restore is finished.
666 flow_restore_wait
667 start_forwarding || return 1
668
669 # Restore saved flows and inform vswitchd that we are done.
670 restore_flows
671 flow_restore_complete
672 add_managers
673 }